> For the complete documentation index, see [llms.txt](https://docs.soniclabs.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.soniclabs.com/sonic/build-on-sonic/integrating-staking.md).

# Integrating Staking

You can build apps on top of Sonic's staking system, such as liquid staking tokens or vaults. All staking operations are managed by the SFC (Special Fee Contract).

* **SFC Address:**\
  `0xFC00FACE00000000000000000000000000000000`
* **Key Functions:**
  * `delegate(validatorID)`: Delegate stake to a validator.
  * `undelegate(validatorID, wrID, amount)`: Begin the withdrawal process.
  * `withdraw(validatorID, wrID)`: Claim unlocked stake after the withdrawal period.
  * `pendingRewards(delegator, validatorID)`: Check claimable rewards.
  * `claimRewards(validatorID)`: Claim pending rewards.
* **Constants**\
  Economic parameters like withdrawal period and reward rates are available by calling the `constsAddress()` on the SFC to get the `ConstantsManager` contract address.
* See [SonicScan](https://sonicscan.org/address/0xFC00FACE00000000000000000000000000000000#code:~:text=Contract-,ABI,-API) for the full SFC ABI.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.soniclabs.com/sonic/build-on-sonic/integrating-staking.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
